<template>
  <div class="editor">
    <!-- Header -->
    <div v-if="editor" class="editor-header">
      <v-slide-group show-arrows>
        <!-- History -->
        <div>
          <!-- Undo -->
          <tiptap-menu-button icon="mdi-undo" :editor="editor" @click="editor.chain().focus().undo().run()" />

          <!-- Redo -->
          <tiptap-menu-button icon="mdi-redo" :editor="editor" @click="editor.chain().focus().redo().run()" />
        </div>

        <v-divider vertical class="mx-2" />

        <!-- General Styling -->
        <div>
          <!-- Bold -->
          <tiptap-menu-button
            active="bold"
            icon="mdi-format-bold"
            :editor="editor"
            @click="editor.chain().focus().toggleBold().run()"
          />

          <!-- Italic -->
          <tiptap-menu-button
            active="italic"
            icon="mdi-format-italic"
            :editor="editor"
            @click="editor.chain().focus().toggleItalic().run()"
          />

          <!-- Strikethrough -->
          <tiptap-menu-button
            active="strike"
            icon="mdi-format-strikethrough"
            :editor="editor"
            @click="editor.chain().focus().toggleStrike().run()"
          />
        </div>

        <v-divider vertical class="mx-2" />

        <!-- Headings -->
        <div>
          <!-- H1 -->
          <tiptap-menu-button
            active="heading"
            :active-options="{ level: 1 }"
            icon="mdi-format-header-1"
            :editor="editor"
            @click="editor.chain().focus().toggleHeading({ level: 1 }).run()"
          />

          <!-- H2 -->
          <tiptap-menu-button
            active="heading"
            :active-options="{ level: 2 }"
            icon="mdi-format-header-2"
            :editor="editor"
            @click="editor.chain().focus().toggleHeading({ level: 2 }).run()"
          />

          <!-- Paragraph -->
          <tiptap-menu-button
            active="paragraph"
            icon="mdi-format-paragraph"
            :editor="editor"
            @click="editor.chain().focus().setParagraph().run()"
          />
        </div>

        <v-divider vertical class="mx-2" />

        <!-- Lists -->
        <div>
          <!-- Bullet List -->
          <tiptap-menu-button
            active="bulletList"
            icon="mdi-format-list-bulleted"
            :editor="editor"
            @click="editor.chain().focus().toggleBulletList().run()"
          />

          <!-- Number list -->
          <tiptap-menu-button
            active="orderedList"
            icon="mdi-format-list-numbered"
            :editor="editor"
            @click="editor.chain().focus().toggleOrderedList().run()"
          />
        </div>

        <v-divider vertical class="mx-2" />

        <!-- Table -->
        <div>
          <!-- Table -->
          <tiptap-menu-button active="table" icon="mdi-table" :editor="editor" @click="tableDialog = true" />

          <!-- Show the table actions when the table is active -->
          <template v-if="editor.isActive('table')">
            <!-- Insert row/column -->
            <v-menu offset-y>
              <!-- Button -->
              <template #activator="{ on, attrs }">
                <tiptap-menu-button
                  icon="mdi-table-row-plus-after"
                  icon-append="mdi-chevron-down"
                  text="Insert"
                  :editor="editor"
                  v-bind="attrs"
                  v-on="on"
                />
              </template>

              <!-- Dropdown -->
              <v-list dense>
                <!-- Row Before -->
                <v-list-item @click="editor.chain().focus().addRowBefore().run()">
                  <!-- Icon -->
                  <v-list-item-icon class="mr-2">
                    <v-icon>mdi-table-row-plus-before</v-icon>
                  </v-list-item-icon>

                  <!--  Content -->
                  <v-list-item-content>
                    <v-list-item-title>Row before</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>

                <!-- Row After -->
                <v-list-item @click="editor.chain().focus().addRowAfter().run()">
                  <!-- Icon -->
                  <v-list-item-icon class="mr-2">
                    <v-icon>mdi-table-row-plus-after</v-icon>
                  </v-list-item-icon>

                  <!--  Content -->
                  <v-list-item-content>
                    <v-list-item-title>Row after</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>

                <!-- Column Before -->
                <v-list-item @click="editor.chain().focus().addColumnBefore().run()">
                  <!-- Icon -->
                  <v-list-item-icon class="mr-2">
                    <v-icon>mdi-table-column-plus-before</v-icon>
                  </v-list-item-icon>

                  <!--  Content -->
                  <v-list-item-content>
                    <v-list-item-title>Column before</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>

                <!-- Column After -->
                <v-list-item @click="editor.chain().focus().addColumnAfter().run()">
                  <!-- Icon -->
                  <v-list-item-icon class="mr-2">
                    <v-icon>mdi-table-column-plus-after</v-icon>
                  </v-list-item-icon>

                  <!--  Content -->
                  <v-list-item-content>
                    <v-list-item-title>Column after</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-list>
            </v-menu>

            <!-- Delete row/column -->
            <v-menu offset-y>
              <!-- Button -->
              <template #activator="{ on, attrs }">
                <tiptap-menu-button
                  icon="mdi-table-remove"
                  icon-append="mdi-chevron-down"
                  text="Delete"
                  :editor="editor"
                  v-bind="attrs"
                  v-on="on"
                />
              </template>

              <!-- Dropdown -->
              <v-list dense>
                <!-- Table -->
                <v-list-item @click="editor.chain().focus().deleteTable().run()">
                  <!-- Icon -->
                  <v-list-item-icon class="mr-2">
                    <v-icon>mdi-table-remove</v-icon>
                  </v-list-item-icon>

                  <!--  Content -->
                  <v-list-item-content>
                    <v-list-item-title>Table</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>

                <!-- Row -->
                <v-list-item @click="editor.chain().focus().deleteRow().run()">
                  <!-- Icon -->
                  <v-list-item-icon class="mr-2">
                    <v-icon>mdi-table-row-remove</v-icon>
                  </v-list-item-icon>

                  <!--  Content -->
                  <v-list-item-content>
                    <v-list-item-title>Row</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>

                <!-- Column -->
                <v-list-item @click="editor.chain().focus().deleteColumn().run()">
                  <!-- Icon -->
                  <v-list-item-icon class="mr-2">
                    <v-icon>mdi-table-column-remove</v-icon>
                  </v-list-item-icon>

                  <!--  Content -->
                  <v-list-item-content>
                    <v-list-item-title>Column</v-list-item-title>
                  </v-list-item-content>
                </v-list-item>
              </v-list>
            </v-menu>
          </template>
        </div>
      </v-slide-group>

      <!-- Table Creation Dialog -->
      <tiptap-table-dialog :open.sync="tableDialog" @insert="tableInsert" />
    </div>

    <!-- Content -->
    <div class="editor-content">
      <editor-content :editor="editor" />
    </div>
  </div>
</template>

<script>
import { Table } from '@tiptap/extension-table'
import { TableCell } from '@tiptap/extension-table-cell'
import { TableHeader } from '@tiptap/extension-table-header'
import { TableRow } from '@tiptap/extension-table-row'
import StarterKit from '@tiptap/starter-kit'
import { Editor, EditorContent } from '@tiptap/vue-2'
import { onBeforeUnmount, reactive, ref } from 'vue-demi'

export default {
  components: { EditorContent },
  props: {
    value: {
      type: String,
      default: '',
    },
  },
  setup(props, { emit }) {
    // Editor value
    const editor = reactive(
      new Editor({
        content: props.value,
        extensions: [StarterKit, Table, TableCell, TableHeader, TableRow],
        onUpdate: () => {
          emit('input', editor.getHTML())
        },
      })
    )

    // Destroy the editor on destroy
    onBeforeUnmount(() => {
      editor.destroy()
    })

    // If the table creation dialog should be open or not
    const tableDialog = ref(false)

    // Insert a table
    function tableInsert(config) {
      editor.chain().focus().insertTable(config).run()
    }

    return {
      editor,
      tableDialog,
      tableInsert,
    }
  },
}
</script>

<style lang="scss" scoped>
.editor {
  background-color: #fff;
  border: 2px solid $primary;
  border-radius: 0.75rem;
  color: #0d0d0d;
  display: flex;
  flex-direction: column;
  height: 400px;

  &-header {
    align-items: center;
    border-bottom: 2px solid $primary;
    display: flex;
    flex: 0 0 auto;
    flex-wrap: wrap;
    padding: 0.25rem;

    &-item {
      border-radius: $border-radius;
      margin-right: 4px;

      &.is-active {
        background-color: rgba($primary, 0.2);
      }
    }
  }

  &-content {
    flex: 1 1 auto;
    overflow-x: hidden;
    overflow-y: auto;
    padding: 1.25rem 1rem;

    div {
      height: 100%;
    }

    ::v-deep.ProseMirror {
      height: 100%;

      p {
        &:last-child {
          margin-bottom: 16px;
        }
      }

      table {
        .selectedCell:after {
          z-index: 2;
          position: absolute;
          content: '';
          left: 0;
          right: 0;
          top: 0;
          bottom: 0;
          background: rgba(lightblue, 0.5);
          pointer-events: none;
        }
      }

      // Resize handle for tables
      .column-resize-handle {
        transition: all $secondary-transition;
        position: absolute;
        right: -2px;
        top: 0;
        bottom: -2px;
        width: 5px;
        background-color: #adf;
        pointer-events: none;
      }
    }

    // Resize cursor for tables
    ::v-deep.ProseMirror.resize-cursor {
      cursor: ew-resize;
      cursor: col-resize;
    }

    ::v-deep.ProseMirror:focus {
      outline: none;
    }
  }
}
</style>
